<script type="module" src="/js/erfassen.js"></script>
<script type="module">
    import {selectAusgabe, wire} from "/js/erfassen.js";
    window.selectAusgabe = selectAusgabe;
    wire();
</script>

<div class="flex flex-row grow gap-2 w-1/5 pl-2">
    <form class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4 max-w-72 dark:bg-gray-900 "
          autocomplete="off" data-hx-post="/fragments/create" data-hx-target="main" data-hx-push-url="/costs"
    >
        <input type="hidden" id="costid" name="id">

        <div class="mb-4">
            <label class="block text-gray-700 dark:text-inherit text-sm font-bold mb-2" for="date" accesskey="1">Datum</label>
            <input class="dark:bg-gray-700 dark:text-inherit shadow appearance-none border rounded w-full py-2 px-3 text-gray-700
                          leading-tight focus:shadow-outline invalid:border-red-500"
                   id="date" name="date" type="date" th:value="${oldValues.getDate()}" required data-hx-validate="true"
                   th:autofocus="${oldValues.isEmpty()}"/>
        </div>
        <div class="mb-4">
            <label class="block text-gray-700 dark:text-inherit text-sm font-bold mb-2" for="name">Bezeichnung</label>
            <input id="name" name="name" type="text"
                   class="dark:bg-gray-700 dark:text-inherit shadow appearance-none border rounded w-full py-2 px-3 text-gray-700
                          leading-tight focus:shadow-outline invalid:border-red-500"
                   th:value="${oldValues.getName()}" list="names" required data-hx-validate="true"/>
            <datalist id="names">
                <option th:each="name: ${names}" th:value="${name}"></option>
            </datalist>
        </div>
        <div class="mb-4">
            <label class="block text-gray-700 dark:text-inherit text-sm font-bold mb-2" for="category">Kategorie</label>
            <input class="dark:bg-gray-700 dark:text-inherit shadow appearance-none border rounded w-full py-2 px-3 text-gray-700
                          leading-tight focus:shadow-outline invalid:border-red-500"
                   id="category" name="category" list="categories" th:value="${category}"
                   th:autofocus="${!oldValues.isEmpty()}" required data-hx-validate="true"
            />
            <datalist id="categories">
                <option th:each="category: ${categories}" th:value="${category}"></option>
            </datalist>
        </div>
        <div class="mb-4">
            <label class="block text-gray-700 dark:text-inherit text-sm font-bold mb-2" for="formula">Betrag</label>
            <textarea rows="1"
                      class="dark:bg-gray-700 dark:text-inherit shadow appearance-none border rounded w-full py-2 px-3 text-gray-700
                             leading-tight focus:shadow-outline invalid:border-red-500"
                      id="formula" name="formula" th:text="${formula}" required data-hx-validate="true"></textarea>
        </div>
        <div th:classappend="${receipt==0}?'hidden'" id="receiptField">
            <label class="block text-gray-700 dark:text-inherit text-sm font-bold mb-2" for="receipt">Belegnr.</label>
            <input th:type="${receipt > 0}?'number':'hidden'"
                   class="dark:bg-gray-700 dark:text-inherit shadow appearance-none border rounded w-full py-2 px-3 text-gray-700
                          leading-tight focus:shadow-outline"
                   id="receipt" name="receipt" required data-hx-validate="true"
                   th:value="${receipt}">
        </div>
        <div class="text-red-600 mb-4" th:text="${error}"></div>
        <div class="flex flex-row flex-wrap gap-2">
            <button class="dark:bg-gray-600 dark:text-gray-200 bg-blue-500 hover:bg-blue-700 text-white font-bold p-0.5 rounded
                           focus:shadow-outline dark:hover:text-gray-800 dark:hover:bg-gray-400"
                    type="submit">Save</button>
            <button class="dark:bg-gray-600 dark:text-inherit bg-blue-500 hover:bg-blue-700 text-white font-bold p-0.5 rounded
                           focus:shadow-outline dark:hover:text-gray-800 dark:hover:bg-gray-400"
                    id="resetButton" type="button" accesskey="2">Reset</button>
            <button th:if="${receipt==0}"
                    class="dark:bg-gray-600 dark:text-inherit bg-blue-500 hover:bg-blue-700 text-white font-bold p-0.5 rounded
                           focus:shadow-outline dark:hover:text-gray-800 dark:hover:bg-gray-400"
                    id="newReceiptButton" type="button"
                    th:text="#{newReceipt}"></button>
            <a class="dark:bg-gray-600 dark:text-inherit bg-blue-500 hover:bg-blue-700 text-white font-bold p-0.5 rounded
                      focus:shadow-outline dark:hover:text-gray-800 dark:hover:bg-gray-400"
               th:href="@{/download}">Download</a>
        </div>
    </form>
    <div class="flex flex-row flex-wrap gap-2 p-1 content-start w-4/5">
        <table class="table with-label">
            <thead class="table-header-group font-bold italic bg-[#00b89c] dark:bg-gray-600">
                <tr class="table-row">
                    <th class="table-cell text-left pr-1 p-1"></th>
                    <th class="table-cell text-left pr-1 p-1" th:text="#{date}"></th>
                    <th class="table-cell text-left pr-1 p-1" th:text="#{name}"></th>
                    <th class="table-cell text-left pr-1 p-1" th:text="#{category}"></th>
                    <th class="table-cell text-right pr-1 p-1" th:text="#{amount}"></th>
                    <th class="table-cell text-right pr-1 p-1" th:utext="#{receipt}"></th>
                    <th class="table-cell text-right pr-1 p-1"></th>
                </tr>
            </thead>
            <tbody class="table-row-group tab-component">
                <tr th:data-id="${costView.getId()}" th:data-date="${costView.getDate()}"
                     th:data-name="${costView.getName()}"
                     th:data-category="${costView.getCategory()}"
                     th:data-formula="${costView.getFormula()}"
                     th:data-receipt="${costView.getReceipt()}"
                     class="table-row even:bg-gray-200 hover:bg-blue-200 dark:even:bg-gray-700 dark:hover:bg-stone-500 dark:has-[:checked]:bg-indigo-50"
                     th:each="costView, iter: ${costs}"
                     ondblclick="selectAusgabe(this)"
                >
                    <td class="table-cell p-1" data-label="Ausw&auml;hlen">
                        <input type="radio" class="dark:bg-gray-500" th:id="${'selectButton'+costView.id}" name="selectButton" th:data-id="${costView.getId()}"
                               data-tab-x="1"
                               th:data-tab-y="${iter.index+1}"
                               onchange="selectAusgabe(this.parentNode.parentNode)"/>
                    </td>
                    <td class="table-cell pr-1 p-1" th:data-label="#{date}">
                        <label th:for="${'selectButton'+costView.id}">
                            <time th:datetime="${costView.date}" th:text="${#temporals.format(costView.date, 'dd.MM.yyyy')}"></time>
                        </label>
                    </td>
                    <td class="table-cell pr-1 p-1" th:text="${costView.name}" th:data-label="#{name}"></td>
                    <td class="table-cell pr-1 p-1" th:text="${costView.category}" th:data-label="#{category}"></td>
                    <td class="table-cell text-right pr-1 p-1" th:title="${costView.formula}" th:data-label="#{amount}"
                         th:text="${#numbers.formatDecimal(costView.amount, 1, 'DEFAULT', 2, 'DEFAULT')}"></td>
                    <td class="table-cell text-right pr-1 p-1" th:data-label="#{receipt}">
                        <mark class="rounded dark:bg-gray-400" th:text="${#numbers.formatDecimal(costView.sum, 1, 'DEFAULT', 2, 'DEFAULT')}"></mark>
                    </td>
                    <td class="table-cell pt-2 pl-3" th:data-label="Löschen">
                        <a href="#"
                           data-tab-x="2"
                           th:data-tab-y="${iter.index+1}"
                           th:attr="data-hx-delete=${'/fragments/delete/' + costView.getId() + '?date=' + costView.date},
                                    data-hx-push-url=${'/costs?date=' + costView.date}"
                           data-hx-target="main">
                            <img class="max-w-4 max-h-4" src="/img/icons8-delete.svg" alt="Delete-Icon"/></a>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</div>
<form method="post" name="delete" action="#"
      data-hx-delete="/fragments/delete" data-hx-target="main" data-hx-push-url="/costs">
    <input type="hidden" name="id"/>
</form>


